(function() {"use strict";var __module = CC_EDITOR ? module : {exports:{}};var __filename = 'preview-scripts/assets/cutScene.js';var __require = CC_EDITOR ? function (request) {return cc.require(request, require);} : function (request) {return cc.require(request, __filename);};function __define (exports, require, module) {"use strict";
cc._RF.push(module, 'ba392bcm99PNKl7zylAqA3N', 'cutScene', __filename);
// cutScene.js

"use strict";

cc.Class({
    extends: cc.Component,

    // use this for initialization
    onLoad: function onLoad() {},

    start: function start() {

        this.maskToSpriteFrameTest();
        //---------------------------------------------------
    },


    /*
    新建一个 RenderTexture，并且设置 camera 的 targetTexture 为新建的 RenderTexture，这样 camera 的内容将会渲染到新建的 RenderTexture 中。
     当子摄像机与渲染对象，在编辑器是active状态时。。。运行游戏直接渲染，就会出现变大或变小的问题。。。
    而当子摄像机与渲染对象，在编辑器是隐藏状态时，运行游戏渲染之前active=ture，就不会有问题。
    刚刚试出来的。。。
    难道这才是正确的使用方式？
    写代码终究是个玄学问题。。。
    */

    maskToSpriteFrameTest: function maskToSpriteFrameTest(data) {

        var testCamera = cc.find("testCamera", this.node);
        var testBoard = cc.find("testBoard", this.node);
        var testSprite = cc.find("testSprite", this.node);
        var testSprite2 = cc.find("testSprite2", this.node);

        var testMaskSprite = cc.find("testMaskSprite", this.node);

        // testBoard.active = true
        // testCamera.active = true
        // testSprite.active = true
        // testSprite2.active = true
        testBoard.scaleY = -1;

        testBoard.getChildByName("boardSprite").getComponent(cc.Sprite).spriteFrame = testMaskSprite.getComponent(cc.Sprite).spriteFrame;
        testBoard.width = testMaskSprite.width;
        testBoard.getChildByName("boardSprite").width = testMaskSprite.width; //子节点高度
        testBoard.height = testMaskSprite.height;
        testBoard.getChildByName("boardSprite").height = testMaskSprite.height; //子节点高度
        var cutPoint = [];
        cutPoint.push(cc.v2(testMaskSprite.width / 2, testMaskSprite.height / 2));
        cutPoint.push(cc.v2(testMaskSprite.width / 2, -testMaskSprite.height / 2));
        cutPoint.push(cc.v2(-testMaskSprite.width / 2, -testMaskSprite.height / 2));
        cutPoint.push(cc.v2(-testMaskSprite.width / 2, testMaskSprite.height / 2));

        var renderTexture = new cc.RenderTexture();
        renderTexture.initWithSize(testMaskSprite.width, testMaskSprite.height, cc.game._renderContext.STENCIL_INDEX8);
        // renderTexture.update({flipY: true});
        renderTexture._premultiplyAlpha = true;
        testCamera.getComponent(cc.Camera).targetTexture = renderTexture;
        testCamera.getComponent(cc.Camera).render();

        var spriteFrame = new cc.SpriteFrame();
        spriteFrame.setTexture(renderTexture);

        testSprite.width = testMaskSprite.width;
        testSprite.height = testMaskSprite.height;

        testSprite2.getComponent(cc.Sprite).spriteFrame = spriteFrame;
        testSprite2.zIndex = cc.macro.MAX_ZINDEX;

        testBoard.active = false; //好像找到问题了。。。注释这行代码就正常了
        // testCamera.active = false
        // testSprite.active = false
    }
});

cc._RF.pop();
        }
        if (CC_EDITOR) {
            __define(__module.exports, __require, __module);
        }
        else {
            cc.registerModuleFunc(__filename, function () {
                __define(__module.exports, __require, __module);
            });
        }
        })();
        //# sourceMappingURL=cutScene.js.map
        